#include "StdAfx.h"
#include "DPCMinfo.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//		const		_CHAR	_strName[]	̃IuWFNg̖O
//	Ԓl
//					
//==============================================================
DPCMinfo::DPCMinfo(MMLfile* MML, bool _bank, const _CHAR _strName[]):
	MusicItem(_strName)
{
	//----------------------
	//Localϐ

	bank = _bank;

//	萔`
enum	Command_ID_mml {
	DPCM_C,
	DPCM_Cis,
	DPCM_D,
	DPCM_Dis,
	DPCM_E,
	DPCM_F,
	DPCM_Fis,
	DPCM_G,
	DPCM_Gis,
	DPCM_A,
	DPCM_Ais,
	DPCM_B,
	DPCM_Note
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		{	"c#",	DPCM_Cis	},
		{	"d#",	DPCM_Dis	},
		{	"f#",	DPCM_Fis	},
		{	"g#",	DPCM_Gis	},
		{	"a#",	DPCM_Ais	},

		{	"c+",	DPCM_Cis	},
		{	"d+",	DPCM_Dis	},
		{	"f+",	DPCM_Fis	},
		{	"g+",	DPCM_Gis	},
		{	"a+",	DPCM_Ais	},

		{	"d-",	DPCM_Cis	},
		{	"e-",	DPCM_Dis	},
		{	"g-",	DPCM_Fis	},
		{	"a-",	DPCM_Gis	},
		{	"b-",	DPCM_Ais	},

		{	"c",	DPCM_C		},
		{	"d",	DPCM_D		},
		{	"e",	DPCM_E		},
		{	"f",	DPCM_F		},
		{	"g",	DPCM_G		},
		{	"a",	DPCM_A		},
		{	"b",	DPCM_B		},

		{	"#",		DPCM_Cis	},
		{	"#",		DPCM_Dis	},
		{	"ӂ#",	DPCM_Fis	},
		{	"#",		DPCM_Fis	},
		{	"#",		DPCM_Gis	},
		{	"#",		DPCM_Ais	},

		{	"-",	DPCM_Cis	},
		{	"-",	DPCM_Dis	},
		{	"-",	DPCM_Fis	},
		{	"-",	DPCM_Gis	},
		{	"-",	DPCM_Ais	},

		{	"",	DPCM_C		},
		{	"",	DPCM_D		},
		{	"",	DPCM_E		},
		{	"ӂ",	DPCM_F		},
		{	"",	DPCM_F		},
		{	"",	DPCM_G		},
		{	"",	DPCM_A		},
		{	"",	DPCM_B		},

		{	"h#",		DPCM_Cis	},
		{	"#",		DPCM_Dis	},
		{	"t@#",	DPCM_Fis	},
		{	"t#",		DPCM_Fis	},
		{	"\#",		DPCM_Gis	},
		{	"#",		DPCM_Ais	},

		{	"-",	DPCM_Cis	},
		{	"~-",	DPCM_Dis	},
		{	"\-",	DPCM_Fis	},
		{	"-",	DPCM_Gis	},
		{	"V-",	DPCM_Ais	},

		{	"h",	DPCM_C		},
		{	"",	DPCM_D		},
		{	"~",	DPCM_E		},
		{	"t@",	DPCM_F		},
		{	"t",	DPCM_F		},
		{	"\",	DPCM_G		},
		{	"",	DPCM_A		},
		{	"V",	DPCM_B		},

		{	"n",	DPCM_Note	}

};

	unsigned	char	cData;

	//------------------------------
	//NX̏ݒ
	max_number	= 0;
	m_id		= 0;

	//------------------------------
	//RpC

	// { ̌
	while(MML->cRead() != '{'){
		if(MML->eof()){
			MML->Err(_T("ubN̊Jn{܂B"));
		}
	}

	// } ܂ŁALqubNRpCB
	while((cData = MML->GetChar()) != '}'){
		
		// } OɁA[EOF]G[
		if( MML->eof() ){
			MML->Err(_T("ubN̏I[`}'܂B"));
		}

		//P߂
		MML->Back();


		//eR}h̏
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){

			case(DPCM_C):
				setKey(MML, 0);
				break;

			case(DPCM_Cis):
				setKey(MML, 1);
				break;

			case(DPCM_D):
				setKey(MML, 2);
				break;

			case(DPCM_Dis):
				setKey(MML, 3);
				break;

			case(DPCM_E):
				setKey(MML, 4);
				break;

			case(DPCM_F):
				setKey(MML, 5);
				break;

			case(DPCM_Fis):
				setKey(MML, 6);
				break;

			case(DPCM_G):
				setKey(MML, 7);
				break;

			case(DPCM_Gis):
				setKey(MML, 8);
				break;

			case(DPCM_A):
				setKey(MML, 9);
				break;

			case(DPCM_Ais):
				setKey(MML, 10);
				break;

			case(DPCM_B):
				setKey(MML, 11);
				break;

			case(DPCM_Note):
				setNote(MML, MML->GetInt());
				break;

			//unknown command
			default:
				MML->Err(_T("unknown command"));
				break;
		}
	}

	//ŊmۂĂB
	if(bank == true){
		iSize = (max_number+1)*6;
	} else {
		iSize = (max_number+1)*4;
	}
	code.resize(iSize);
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
DPCMinfo::~DPCMinfo(void)
{
	//PCḾAŔjB

	//----------------------
	//Localϐ
	map<string, DPCM*>::iterator	itItem;

	//----------------------
	//Delete Class
	if(!ptcDPCM.empty()){
		itItem = ptcDPCM.begin();
		while(itItem != ptcDPCM.end()){
			delete itItem->second;
			itItem++;
		}
		ptcDPCM.clear();
	}
}
//==============================================================
//		ݒ
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//			int	key		L[ԍi0:C / 1:Cis / ...j
//	Ԓl
//				
//==============================================================
void	DPCMinfo::setKey(MMLfile* MML, int key)
{
	setNote(MML, ((MML->GetInt()-1) * 12) + key);
}

//==============================================================
//		ݒ
//--------------------------------------------------------------
//	
//		MMLfile*		MML		MMLt@C̃IuWFNg
//				int		note	m[gԍ
//	Ԓl
//				
//==============================================================
void	DPCMinfo::setNote(MMLfile* MML, int note)
{
	unsigned	char	cData;
				int		play_frequency;
				int		mode			= 0;
				int		start_volume	= 0x40;
				int		next;
				int		start_offset;
				int		size_offset;
	DPCM*		_DPCM;

	if((note<0) || (note>255)){
		MML->Err(_T("K͈̔͂𒴂Ă܂B"));
	}

	if(max_number < note){
		max_number = (unsigned char)note;
	}

	//t@C
	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(_T("PCM`̃p[^܂B"));
	}

	infoDPCM[note].file = MML->GetString();
	if(ptcDPCM.count(infoDPCM[note].file) == 0){
		//Vt@CADPCMIuWFNg𐶐B
		_DPCM = new DPCM(MML, infoDPCM[note].file.c_str(), m_id);
		ptcDPCM[infoDPCM[note].file] = _DPCM;
		m_id++;
	} else {
		_DPCM = ptcDPCM[infoDPCM[note].file];
	}

	//Đg
	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(_T("PCM`̃p[^܂B"));
	}
	play_frequency = MML->GetInt();
	if((play_frequency<0) || (play_frequency>15)){
		MML->Err(_T("PCM̎g0`15͈̔͂Ŏw肵ĉB"));
	}

	//[h
	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(_T("PCM`̃p[^܂B"));
	}

	mode = MML->GetInt();
	if((mode<0) || (mode>2)){
		MML->Err(_T("PCM̃[h0`2͈̔͂Ŏw肵ĉB"));
	}
	if((mode==2) && (bank==false)){
		MML->Err(_T("PCM̃[h2(IRQ)́A#BankR}h̎w肪KvłB"));
	}
	infoDPCM[note].ctrl = (unsigned char)(mode<<6) + (unsigned char)play_frequency;

	//l
	cData = MML->GetChar();
	if(cData == ','){
		start_volume = MML->GetInt();	
		if((start_volume<-1) || (start_volume>127)){
			MML->Err(_T("PCM̏l-1`127͈̔͂Ŏw肵ĉB"));
		}
		infoDPCM[note].DA = (unsigned char)start_volume;
	} else {
		MML->Back();
		infoDPCM[note].DA = 0;
	}

	//̃m[g
	if(mode == 2){
		cData = MML->GetChar();
		if(cData == ','){
			next = MML->GetInt();	
			if((next<-1) || (next>255)){
				MML->Err(_T("̃m[gԍ0`255͈̔͂Ŏw肵ĉB"));
			}
			infoDPCM[note].next = (unsigned char)next;
		} else {
			if(mode == 2){
				MML->Err(_T("[h2(IRQ)͕̎Kɔm[gԍw肵ĂB"));
			}
			MML->Back();
			infoDPCM[note].next = 0;
		}
	} else {
		infoDPCM[note].next = 0;
	}
/*
	cData = MML->GetChar();
	if(cData == ','){
		if(mode != 2){
			MML->Err(_T("[h2(IRQ)ȊÕ[hł͕svłB"));
		}
		next = MML->GetInt();	
		if((next<-1) || (next>255)){
			MML->Err(_T("̃m[gԍ0`255͈̔͂Ŏw肵ĉB"));
		}
		infoDPCM[note].next = (unsigned char)next;
	} else {
		if(mode == 2){
			MML->Err(_T("[h2(IRQ)͕̎Kɔm[gԍw肵ĂB"));
		}
		MML->Back();
		infoDPCM[note].next = 0;
	}
*/

	//offset
	cData = MML->GetChar();
	if(cData == ','){
		start_offset = MML->GetInt();	
		if((start_offset<0) || (start_offset>255)){
			MML->Err(_T("PCM̔JnItZbg0`255͈̔͂Ŏw肵ĉB"));
		}
		infoDPCM[note].offset = (unsigned char)start_offset;
	} else {
		MML->Back();
		infoDPCM[note].offset = 0;
	}

	//size
	cData = MML->GetChar();
	if(cData == ','){
		size_offset = MML->GetInt();	
		if((size_offset<0) || (size_offset>255)){
			MML->Err(_T("PCM̔TCY0`255͈̔͂Ŏw肵ĉB"));
		}
		infoDPCM[note].size = (unsigned char)size_offset;
	} else {
		MML->Back();
		infoDPCM[note].size = 0;
	}

}

//==============================================================
//		PCMinfo\̂̐izuAhX̉j
//--------------------------------------------------------------
//	
//		unsigned	int		_offset		PCMzuAhX
//		unsigned	char	_MusBank	V[PX̃oN
//	Ԓl
//		unsigned	int					PCMzuIAhX
//	
//		R[h擾ȂAePCM̃oCi𓾂B
//		iR[h́ANSFo͂̎gȂBBBj
//==============================================================
unsigned	int	DPCMinfo::setDPCMoffset(unsigned	int _offset, unsigned char _MusBank)
{
	map<string, DPCM*>::iterator	itDPCM;
	DPCM*	_DPCM;
	size_t	_size;

	unsigned	int	i=0;

	//PCM̔zuAhXBȂNSFo͗ṗPCM̂쐬B
	if(m_id > 0){
		//DPCM
		if(!ptcDPCM.empty()){
			itDPCM = ptcDPCM.begin();
			while(itDPCM != ptcDPCM.end()){
				_DPCM = itDPCM->second;
				_DPCM->SetOffset(_offset);
				_size	= (_DPCM->getSize() & 0xFFC0) + 0x0040;
				_offset	+= (unsigned int)_size;
				itDPCM++;
			}
		}
	}

	//PCMinfo\̂̐
	if(bank == false){
		while(i <= max_number){
			if(infoDPCM[i].file.empty()){
				code[i*4 + 0] = 0;
				code[i*4 + 1] = 0;
				code[i*4 + 2] = 0;
				code[i*4 + 3] = 0;
			} else {
				_DPCM = ptcDPCM[infoDPCM[i].file];
				code[i*4 + 0] = infoDPCM[i].ctrl;
				code[i*4 + 1] = infoDPCM[i].DA;
				code[i*4 + 2] = (unsigned char)((_DPCM->getOffset() - 0xC000) >> 6) + infoDPCM[i].offset;
				if(infoDPCM[i].size == 0){
					if(_DPCM->getDPCMsize() >= (infoDPCM[i].offset*4)){
                        code[i*4 + 3] = _DPCM->getDPCMsize() - (infoDPCM[i].offset*4);
					} else {
						code[i*4 + 3] = 0;
					}
				} else {
					code[i*4 + 3] = infoDPCM[i].size;
				}
			}
			i++;
		}
	} else {
		while(i <= max_number){
			if(infoDPCM[i].file.empty()){
				code[i*6 + 0] = 0;
				code[i*6 + 1] = 0;
				code[i*6 + 2] = 0;
				code[i*6 + 3] = 0;
				code[i*6 + 4] = 0;
				code[i*6 + 5] = 0;
			} else {
				_DPCM = ptcDPCM[infoDPCM[i].file];
				code[i*6 + 0] = infoDPCM[i].ctrl;
				code[i*6 + 1] = infoDPCM[i].DA;
				code[i*6 + 2] = (unsigned char)((_DPCM->getOffset() & 0x0FFF) >> 6) + infoDPCM[i].offset;
				if(infoDPCM[i].size == 0){
					if(_DPCM->getDPCMsize() >= (infoDPCM[i].offset*4)){
                        code[i*6 + 3] = _DPCM->getDPCMsize() - (infoDPCM[i].offset*4);
					} else {
						code[i*6 + 3] = 0;
					}
				} else {
					code[i*6 + 3] = infoDPCM[i].size;
				}

				code[i*6 + 4] = (unsigned char)((_DPCM->getOffset() - 0xC000) / 0x1000) + _MusBank;
				code[i*6 + 5] = infoDPCM[i].next;
			}
			i++;
		}
	}


	return(_offset);
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		string*		_str		R[hstring̃|C^
//	Ԓl
//		
//	
//		R[h擾ȂAePCM̃oCi𓾂B
//		iR[h́ANSFo͂̎gȂBBBj
//==============================================================
void	DPCMinfo::getDPCMCode(string* _str)
{
	map<string, DPCM*>::iterator	itDPCM;
	DPCM*	_DPCM;
	size_t	_size;
	size_t	psize;

	if(m_id > 0){
		//DPCM
		if(!ptcDPCM.empty()){
			itDPCM = ptcDPCM.begin();
			while(itDPCM != ptcDPCM.end()){
				_DPCM = itDPCM->second;
				_DPCM->getCode(_str);
				_size	= _DPCM->getSize();
				psize	= (_size & 0xFFC0) + 0x0040;
				_str->append(psize - _size,(char)0x00);
				itDPCM++;
			}
		}
	}
}
//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	DPCMinfo::getAsm(MusicFile* MUS)
{
	map<string, DPCM*>::iterator	itDPCM;

	if(m_id > 0){
		//DPCMinfo
		*MUS << MUS->Header.Label.c_str() << "DPCMinfo" << ":" << endl;
		MusicItem::getAsm(MUS);

		//DPCM
		if((!ptcDPCM.empty()) && (MUS->Header.segmentPCM != "")) {
			*MUS <<	"\n\n.segment	"	<<	'"'	<<	MUS->Header.segmentPCM	<<	'"' << endl;
			itDPCM = ptcDPCM.begin();
			while(itDPCM != ptcDPCM.end()){
				itDPCM->second->getAsm(MUS);
				itDPCM++;
			}
			*MUS <<	"\n\n.segment	"	<<	'"'	<<	MUS->Header.segmentSEQ	<<	'"' << endl;
		}
	}
}
