#include "StdAfx.h"
#include "Envelop.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//		unsigned	int		_id			Gx[vԍ
//		const		_CHAR	_strName[]	IuWFNg
//	Ԓl
//					
//==============================================================
Envelop::Envelop(MMLfile* MML, unsigned int _id, const _CHAR _strName[]):
	MusicItem(_id, _strName),
	f_Use(false),
	m_id(_id)
{
	//----------------------
	//Localϐ


//	萔`
enum	Command_ID_mml {
	Env_Num,
	Env_Sweep,
	Env_Hold,
	Env_Loop,
	Env_Release,
	Env_Commma
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		{	"$",	Env_Num		},
		{	"%",	Env_Num		},
		{	"-",	Env_Num		},
		{	"0",	Env_Num		},
		{	"1",	Env_Num		},
		{	"2",	Env_Num		},
		{	"3",	Env_Num		},
		{	"4",	Env_Num		},
		{	"5",	Env_Num		},
		{	"6",	Env_Num		},
		{	"7",	Env_Num		},
		{	"8",	Env_Num		},
		{	"9",	Env_Num		},
		{	"{",	Env_Sweep	},
		{	"(",	Env_Sweep	},
		{	"d",	Env_Hold	},
		{	"D",	Env_Hold	},
		{	"",	Env_Hold	},
		{	"c",	Env_Hold	},
		{	"|",	Env_Loop	},
		{	"b",	Env_Loop	},
		{	"l",	Env_Loop	},
		{	"L",	Env_Loop	},
		{	"",	Env_Loop	},
		{	"k",	Env_Loop	},
		{	"r",	Env_Release	},
		{	"R",	Env_Release	},
		{	"",	Env_Release	},
		{	"q",	Env_Release	},
		{	"@",	Env_Commma	},
		{	"C",	Env_Commma	},
		{	"A",	Env_Commma	},
		{	",",	Env_Commma	}
};

	unsigned	char	cData;
				int		i;

	//------------------------------
	//NX̏ݒ

	Loop_Normal		= -1;
	Loop_Release	= -1;
	Release			= false;
	ptEnvelop		= 1;

	code.resize(0);
	code.append((char)1, (char)0);



	//------------------------------
	//RpC

	// { ̌
	while(MML->cRead() != '{'){
		if(MML->eof()){
			MML->Err(_T("ubN̊Jn{܂B"));
		}
	}

	// } ܂ŁALqubNRpCB
	while((cData = MML->GetChar()) != '}'){
		
		// } OɁA[EOF]G[
		if( MML->eof() ){
			MML->Err(_T("ubN̏I[`}'܂B"));
		}

		//P߂
		MML->Back();


		//eR}h̏
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){

			case(Env_Num):
				MML->Back();
				i = MML->GetInt();
				if( (i<-64) || (i>127)){
					MML->Err(_T("Gx[v-64`127͈̔͂Ŏw肵ĉB"));
				}
				code.append((char)1, (char)i & 0x7F);
				ptEnvelop++;
				break;

			case(Env_Sweep):
				sweep(MML);
				break;

			case(Env_Hold):
				i = MML->GetInt();
				if( (i<0) || (i>255)){
					MML->Err(_T("ێԂ0`255͈̔͂Ŏw肵ĉB"));
				}
				setHold(i);
				break;

			case(Env_Loop):
				if(ptEnvelop > 0x3F){
					MML->Err(_T("[vʒuwł͈͂𒴂܂B"));
				}
				if(Release == false){
					Loop_Normal		= ptEnvelop;
				} else {
					Loop_Release	= ptEnvelop;
				}
				break;

			case(Env_Release):
				if(Loop_Normal == -1){
					MML->Warning(_T("[v|Cg܂BŌ̒l[v܂B"));
					code.append((char)1, (char)(ptEnvelop-1 | 0xC0));
				} else {
					if(ptEnvelop == Loop_Normal){
						MML->Err(_T("LR}h̒RR}huƂ͂ł܂B"));
					}
					code.append((char)1, (char)(Loop_Normal | 0xC0));
				}
				ptEnvelop++;
				code[0] = (unsigned char)ptEnvelop;
				Release = true;
				break;

			case(Env_Commma):
				break;

			//unknown command
			default:
				MML->Err(_T("unknown command"));
				break;
		}
	}

	if(Release == true){
		if(Loop_Release == -1){
			MML->Warning(_T("[X̃[v|Cg܂BŌ̒l[v܂B"));
			code.append((char)1, (char)(ptEnvelop-1 | 0xC0));
		} else {
			if(ptEnvelop == Loop_Release){
				MML->Err(_T("LR}hŃp^[`I邱Ƃ͂ł܂B"));
			}
			code.append((char)1, (char)(Loop_Release | 0xC0));
		}
	} else {
		if(Loop_Normal == -1){
			MML->Warning(_T("[v|Cg܂BŌ̒l[v܂B"));
			code.append((char)1, (char)(ptEnvelop-1 | 0xC0));
		} else {
			if(ptEnvelop == Loop_Normal){
				MML->Err(_T("LR}hŃp^[`I邱Ƃ͂ł܂B"));
			}
			code.append((char)1, (char)(Loop_Normal | 0xC0));
		}
	}

	if(code.size() > 256){
		MML->Err(_T("Gx[v̒`256Bytez܂B"));
	}

	iSize = code.size();
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
Envelop::~Envelop(void)
{
}

//==============================================================
//		ێԂ̃Zbg
//--------------------------------------------------------------
//	
//		int		length		ێ
//	Ԓl
//				
//==============================================================
void	Envelop::setHold(int length)
{
	while(length>15){
		code.append((char)1, (unsigned char)0x8F);
		ptEnvelop++;
		length -= 16;		//15΁A16t[ێ
	}
	code.append((char)1, (char)((length & 0x0F) | 0x80));
	ptEnvelop++;
}

//==============================================================
//		XC[v
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
void	Envelop::sweep(MMLfile* MML)
{
	unsigned	char	cData;

	int		iStart;
	int		iEnd;
	int		iLength;
	int		iDelta;

	int		now	= 0;
	int		cnt	= 0;

	int		i=0;
	int		temp;

	//--------------------------
	//MMLǂݍ

	//
	iStart = MML->GetInt();
	if( (iStart<-64) || (iStart>127)){
		MML->Err(_T("Jn_-64`127͈̔͂Ŏw肵ĉB"));
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(_T("p[^܂B"));
	}

	iEnd = MML->GetInt();
	if( (iEnd<-64) || (iEnd>127)){
		MML->Err(_T("I_-64`127͈̔͂Ŏw肵ĉB"));
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(_T("p[^܂B"));
	}

	iLength = MML->GetInt();
	if( (iLength<1) || (iLength>255)){
		MML->Err(_T("1`255͈̔͂Ŏw肵ĉB"));
	}

	cData = MML->GetChar();
	if((cData != ')') && (cData != '}')){
		MML->Err(_T("p[^܂B"));
	}

	//--------------------------
	//e[u쐬

	iDelta = iEnd - iStart;

	while(i<iLength){
		temp = iStart + (iDelta * i) / iLength;
		if(i == 0){
			now = temp;
			cnt	= 0;
		} else if (temp != now){
			code.append((char)1, (char)now & 0x7F);
			ptEnvelop++;
			if(cnt>=1){
				setHold(cnt-1);
			}
			now = temp;
			cnt	= 0;
		} else {
			cnt++;
		}
		i++;
	}

	code.append((char)1, (char)now & 0x7F);
	ptEnvelop++;
	if(cnt>=1){
		setHold(cnt-1);
	}

}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	Envelop::getAsm(MusicFile* MUS)
{
	*MUS << MUS->Header.Label.c_str() << "Envelope" << m_id << ":" << endl;
	MusicItem::getAsm(MUS);
}
