#include "StdAfx.h"
#include "FileInput.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
FileInput::FileInput(void):
	readData(0),
	iLine(1)
{
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
FileInput::~FileInput(void)
{
}

//--------------------------------
//t@CJ@G[t
//--------------------------------
void	FileInput::fileopen(const char*	_strFileName){

	errno = 0;	//O[oϐ errno Oɏ
	clear();	//tÕNA

	open(_strFileName,ios_base::in | ios_base::binary);
	if(good()==false){
		perror(_strFileName);
		nsc_exit(EXIT_FAILURE);
	};
	strFilename = _strFileName;
};

//--------------------------------
//t@CJ@G[t
//--------------------------------
void	FileInput::fileopen(const char*	_strFileName,SearchPass* _pass)
{
	bool	success	= false;

	//悸́Â܂
	errno = 0;	//O[oϐ errno Oɏ
	clear();	//tÕNA
	open(_strFileName,ios_base::in | ios_base::binary);
	if(cOptionSW->flag_SearchPass){
		perror(_strFileName);
	}

	if(good()==true){
		success = true;
	} else {

		//pX
		int		i		= 0;
		int		iSize	= _pass->count();
		string	name;
		string	workName= string(_strFileName);
		int		loc		= workName.rfind('/');

		//w̃t@CɃpXĂAB
		if(loc != string::npos){
			workName.erase(0, loc);		//t@Ĉ
		}

		while(i < iSize){

#ifdef _WIN32
			//Windows̏ꍇ́A΃pX܂߂ČiUNIXn͕sj
			//w̌pXƂ΃pXB
			errno = 0;	//O[oϐ errno Oɏ
			clear();	//tÕNA

			name.assign(_pass->get(i));
			name.append(_strFileName);
			open(name.c_str(),ios_base::in | ios_base::binary);
			if(cOptionSW->flag_SearchPass){
				perror(name.c_str());
			}
			if(good()==true){
				success = true;
				break;
			};
#endif
			//WINDOWS, UNIXn
			//pX{t@Ĉ݂ŌB
			errno = 0;	//O[oϐ errno Oɏ
			clear();	//tÕNA

			name.assign(_pass->get(i));
			name.append(workName);
			open(name.c_str(),ios_base::in | ios_base::binary);
			if(cOptionSW->flag_SearchPass){
				perror(name.c_str());
			}
			if(good()==true){
				success = true;
				break;
			};

			i++;
		}

	};

	if(success == false){
		_CERR << _T("SĂ̌pXŁAt@C܂łB") << endl;
		if(cOptionSW->flag_SearchPass == false){
			perror(_strFileName);
		}
		nsc_exit(EXIT_FAILURE);
	}
}

//--------------------------------
//΃V[N
//--------------------------------
void	FileInput::StreamPointerAdd(long iSize){
	seekg((long)iSize,ios::cur);
};

//--------------------------------
//΃V[N
//--------------------------------
void	FileInput::StreamPointerMove(long iSize){
		seekg((long)iSize,ios::beg);
};

void	FileInput::Back(void)
{
	StreamPointerAdd(-1);
	if(readData == 0x0A){
		iLine--;
	}

	//XV
	read((char*)&readData, sizeof(unsigned char));
	StreamPointerAdd(-1);
}
//--------------------------------
//1Byteǂݍ
//--------------------------------
unsigned	char	FileInput::cRead()
{
	read((char*)&readData, sizeof(unsigned char));
	if(readData == 0x0A){
		iLine++;
	}

	return(readData);
};
//--------------------------------
//TCY
//--------------------------------
unsigned	int	FileInput::GetSize(){

	unsigned	int	iData;
	unsigned	int	iDataT = tellg();

	seekg(0		,ios::end);
	iData = tellg();
	seekg(iDataT,ios::beg);

	return(iData);
};
