#include "StdAfx.h"
#include "MMLfile.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		const	char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
MMLfile::MMLfile(const char*	strFileName):
	offset_Ei(0),
	offset_Ev(0),
	offset_En(0),
	offset_Em(0),
	iReleaseVolume(2),
	iRepeatMode(0),
	iTieMode(0),
	timebase(24),
	octave_reverse(false),
	q_reverse(false),
	rest(2),
	wait(0),
	QMax(8),
	priority(0),
	p_macro(0),
	f_macro(false),
	f_2to1(false)
	{
	//File open
	nowFile	= new FileInput();

	nowFile->fileopen(strFileName);
	ptcFiles.push_back(nowFile);

	iFiles = 0;
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MMLfile::~MMLfile(void)
{

	//----------------------
	//Localϐ
	vector	<FileInput*				>::iterator	itFiles;
	map		<string,		string	>::iterator	itMac;
	map		<unsigned int,	Patch*	>::iterator	itPatch;

	//----------------------
	//Delete Class

	//Jt@CS
	itFiles = ptcFiles.begin();
	while(itFiles != ptcFiles.end()){
		(*itFiles)->close();
		delete *itFiles;
		itFiles++;
	}
	ptcFiles.clear();

	//}NSB
	if(!ptcMac.empty()){
		itMac = ptcMac.begin();
		while(itMac != ptcMac.end()){
			itMac->second.clear();
			itMac++;
		}
		ptcMac.clear();
	}
	lv_Mac.clear();

	//pb`SB
	if(!ptcPatch.empty()){
		itPatch = ptcPatch.begin();
		while(itPatch != ptcPatch.end()){
			delete	itPatch->second;
			itPatch++;
		}
		ptcPatch.clear();
	}

}

//==============================================================
//			݃RpC̃t@C[EOF]`FbN
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			bool		true	[EOF]o
//						false	܂I肶ȂB
//==============================================================
bool	MMLfile::eof(void)
{
	return( nowFile->eof() );
}

//==============================================================
//			MMLt@C̏I`FbN
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			bool		true	t@C[EOF]o
//						false	܂I肶ȂB
//==============================================================
bool	MMLfile::eom(void)
{
	if(( iFiles == 0 ) && ( eof() )){
		return(true);
	}
	return(false);
}

//==============================================================
//		CN[ht@C
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//	
//			݂̃t@C|C^ɏĂt@CCN[h
//==============================================================
void	MMLfile::include()
{
	//----------------------
	//Localϐ
	vector	<FileInput*>::iterator	itFiles;
	string	_name = GetString();

	//----------------------
	//t@CJĂȂ`FbN
	itFiles = ptcFiles.begin();
	while(itFiles != ptcFiles.end()){
		if( *(*itFiles)->GetFilename() == _name ){
			Err(_T("ɓt@C#includeŊJĂ܂B"));
		}
		itFiles++;
	}

	//----------------------
	//File open
	nowFile	= new FileInput();

	nowFile->fileopen(_name.c_str(), &cOptionSW->m_pass_inc);
	ptcFiles.push_back(nowFile);

	iFiles++; 
}

//==============================================================
//		}N̐ݒ
//--------------------------------------------------------------
//	
//		int		i_Lv	ݒ肷郌x
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}N`B
//==============================================================
void	MMLfile::SetMacro(int i_Lv)
{
	char	cData;
	string	macro_name		="";
	string	macro_contents	="";

	int		iKakko	= 0;

	//------------------
	//}N̎擾
	while((cData = cRead()) > 0x20){
		if(cData == '{'){
			break;
		}
		macro_name += cData;
	};
	Back();

	//------------------
	//}N̏d`FbN
	if(ptcMac.count(macro_name) != 0){
		Err(_T("ɂ̃}N݂͑Ă܂B"));
	}

	//------------------
	//}Ne̎擾
	while(cRead() != '{'){
		if(eof()){
			Err(_T("Jn{܂B"));
		}
	}

	while(('}' != (cData = cRead())) || (iKakko != 0)){
		if(eof()){
			Err(_T("I}܂B"));
		}
		if(cData == '{'){
			iKakko++;
		} else if(cData == '}'){
			iKakko--;
		}
		macro_contents += cData;
	}
	macro_contents += " ";

	//------------------
	//}Ne̐ݒ
	ptcMac[macro_name] = macro_contents;
	lv_Mac[macro_name] = i_Lv;

}

//==============================================================
//		}N̐ݒ
//--------------------------------------------------------------
//	
//		int		i_Lv	폜郌x
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}N`B
//==============================================================
void	MMLfile::DeleteMacro(int i_Lv)
{

	//----------------------
	//Localϐ
	map		<string,		string	>::iterator	itMac;
	string	macro_name;
	int		macro_lv;

	//----------------------
	//YLṽ}NB
	if(!ptcMac.empty()){
		itMac = ptcMac.begin();
		while(itMac != ptcMac.end()){
			macro_name	= itMac->first;
			macro_lv	= lv_Mac[macro_name];
			itMac++;
			if(i_Lv == macro_lv){
				ptcMac.erase(macro_name);
				lv_Mac.erase(macro_name);
			}
		}
	}

}

//==============================================================
//		}ŇĂяo
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}NĂяo
//==============================================================
void	MMLfile::CallMacro(void)
{
	char							cData;
	int								i		= 0;
	int								n		= 0;
	int								iSize	= ptcMac.size();
	string							_name	= "";
	string*							strMac	= new	string[iSize];
	map<string,string>::iterator	itMac	= ptcMac.begin();

	//------------------
	//S}N̎擾
	if(!ptcMac.empty()){
		do{
			strMac[i] = itMac->first;
			i++;
			itMac++;
		}while(itMac != ptcMac.end());
	}

	//------------------
	//}N̏ƍ
	do{
		cData = cRead();
		_name += cData;
		i = 0;			//[vp
		n = 0;			//qbg
		if(cData > 0x20){
			while(i<iSize){
				if(strMac[i].find(_name.c_str()) == 0){
					n++;		//}N擪qbg
				}
				i++;
			}
		}
	} while(n>0);		//qbg0ɂȂ܂ŁAJԂB

	Back();										//|C^P߂B
	_name = _name.substr(0, _name.length()-1);	//P炷B

	//------------------
	//}N̑݃`FbN
	if(ptcMac.count(_name) == 0){
		Err(_T("̃}N݂͑Ă܂B"));
	}

	//------------------
	//}N̏d`FbN
	i = 0;
	while(i < p_macro){
		if(s_macro[i].name == _name){
			Err(_T("}Nœ}NĂяoĂ܂B"));
		}
		i++;
	}

	//------------------
	//lXgۑ
	if(p_macro > 0){
		s_macro[p_macro-1].name = nowMacro.name;
		s_macro[p_macro-1].line = nowMacro.line;
	}

	nowMacro.name = _name;
	nowMacro.line = 0;

	s_macro.push_back(nowMacro);
	p_macro++;

	delete[]	strMac;
}

//==============================================================
//		pb`̐ݒ
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}N`B
//==============================================================
void	MMLfile::SetPatch(void)
{

	int			i		= GetNum();

	//d`FbN
	if(ptcPatch.count(i) != 0){
		Err(_T("Patch()ubNœԍw肳܂B"));
	}

	ptcPatch[i] =  new Patch(this, i);

}

//==============================================================
//		pb`̗L`FbN
//--------------------------------------------------------------
//	
//			unsigned int _no	pb`ԍ
//	Ԓl
//			bool				邩ǂ
//	
//			
//==============================================================
bool	MMLfile::ChkPatch(unsigned int _no)
{
	bool	result;

	if(ptcPatch.count(_no) == 0){
		result = false;
	} else {
		result = true;
	}
	return(result);
}

//==============================================================
//			݃RpC̃t@C|C^̎擾
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		݂̃t@C|C^
//==============================================================
int		MMLfile::tellg(void)
{
	int	i;

	if(p_macro > 0){
		i = nowMacro.line;
	} else {
		i = nowFile->tellg();
	}

	return(i);
}

//==============================================================
//			݃RpC̃t@C|C^ΓIɈړ
//--------------------------------------------------------------
//	
//			long	iSize	ړl
//	Ԓl
//			
//==============================================================
void	MMLfile::StreamPointerMove(long iSize)
{
	if(p_macro > 0){
		nowMacro.line = iSize;
	} else {
		nowFile->StreamPointerMove(iSize);
	}
}

//==============================================================
//			݃RpC̃t@C|C^߂
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//==============================================================
void	MMLfile::Back_one(void)
{
	if(f_macro == true){
		f_macro = false;
		if(p_macro > 0){
			s_macro[p_macro-1].name = nowMacro.name;
			s_macro[p_macro-1].line = nowMacro.line;
		}
		p_macro++;
		nowMacro.name = s_macro[p_macro-1].name;
		nowMacro.line = s_macro[p_macro-1].line;
		nowMacro.line--;
	} else {
		if(p_macro > 0){
			nowMacro.line--;
		} else {
			nowFile->Back();
		}
	}
}

void	MMLfile::Back(void)
{
	if(f_2to1==true){
		Back_one();
		Back_one();		//O̓ǂݍ݂}`oCgAQ߂B
	} else {
		Back_one();
	}

}

//==============================================================
//			PByteǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//==============================================================
char	MMLfile::read_char(void)
{
	char	cData;

	//O̓ǂݍ݂ŁA}N̏I[ɍsB
	if(f_macro == true){
		f_macro	= false;		
		s_macro.pop_back();		//}NX^bNP߂B
	}

	if(p_macro > 0){
		//}Nǂݍޏꍇ
		cData = ptcMac[nowMacro.name][nowMacro.line];
		nowMacro.line++;
		//}NI[H
		if(ptcMac[nowMacro.name].size() == nowMacro.line){
			s_macro[p_macro-1].name = nowMacro.name;
			s_macro[p_macro-1].line = nowMacro.line;
			p_macro--;
			f_macro	= true;
			if(p_macro > 0){
				nowMacro.name = s_macro[p_macro-1].name;
				nowMacro.line = s_macro[p_macro-1].line;
			}
		}
	} else {
		//t@Cǂݍޏꍇ
		cData		= nowFile->cRead();
	}

	return(cData);

}

//==============================================================
//			PByteǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//==============================================================
char	MMLfile::cRead(void)
{
	unsigned	char	cData = read_char();
	unsigned	char	cDataMSB;

	switch(cData){
		case(0x81):
			cDataMSB = read_char();
			f_2to1 = true;
			switch(cDataMSB){
				case(0x69):
					cData = '(';
					break;
				case(0x6A):
					cData = ')';
					break;
				case(0x6F):
					cData = '{';
					break;
				case(0x70):
					cData = '}';
					break;
				case(0x7B):
					cData = '+';
					break;
				case(0x7C):
					cData = '-';
					break;
				case(0x94):	//
					cData = '#';
					break;
				case(0xF3):	//
					cData = '-';
					break;
				default:
					f_2to1 = false;
					Back();
					break;
			}
			break;

		case(0x82):
			cDataMSB = read_char();
			f_2to1 = true;
			switch(cDataMSB){
				case(0x4F):
					cData = '0';
					break;
				case(0x50):
					cData = '1';
					break;
				case(0x51):
					cData = '2';
					break;
				case(0x52):
					cData = '3';
					break;
				case(0x53):
					cData = '4';
					break;
				case(0x54):
					cData = '5';
					break;
				case(0x55):
					cData = '6';
					break;
				case(0x56):
					cData = '7';
					break;
				case(0x57):
					cData = '8';
					break;
				case(0x58):
					cData = '9';
					break;
				default:
					f_2to1 = false;
					Back();
					break;
			}
			break;

		default:
			f_2to1 = false;
			break;
	}

	return(cData);
}

//==============================================================
//			PByteǂݍ݁i`FbNtj
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//	
//		P̓ǂݍ݁B
//		AAȉ̋Lqꍇ́A΂B
//			E0x20ȉ̃LN^[R[h
//			ERg
//		܂ACN[ht@C[EOF]oAÕt@Cɖ߂
//==============================================================
char	MMLfile::GetChar(void)		//1Byte̓ǂݍ
{
	unsigned	char	cData;

	do{
		cData = cRead();

		//[EOM]H
		if( eom() )
		{
			return(0);

		//[EOF]H
		} else if( eof() ){
			nowFile->close();
			delete	nowFile;
			ptcFiles.pop_back();
			nowFile = ptcFiles.back();
			iFiles--;
			//continue

		//0x20ȉ̐R[h
		} else if(cData <= 0x20){
			//continue

		//AZu^CṽRgH
		} else if(cData == ';'){
			do{
				cData = cRead();		//̃oCgǂݍ
			} while((cData != 0x0A)||eof());
		
		//b^CṽRgH
		} else 	if(cData == '/'){
			cData = cRead();		//̃oCgǂݍ
			switch(cData){

				//PsRg
				case('/'):
					do{
						cData = cRead();		//̃oCgǂݍ
					}while((cData != 0x0A)||eof());
					break;

				//͈̓Rg
				case('*'):
					do{
						do{
							cData = cRead();		//̃oCgǂݍ
							if(eof()){
								Err(_T("RgI[ */ ܂B"));
							}
						}while(cData != '*');
						cData = cRead();
						Back();					//StreamPointerAdd(-1);
					} while(cData != '/');
							cRead();			//StreamPointerAdd(+1); B
					break;

				//ȊO
				default:
					Err(_T("RgłH"));
					break;
			}

		//[EOF]łARgłꍇB
		} else {
			break;		//while(1)  break;
		}

	} while(true);

	return(cData);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			string	ǂݍ񂾕
//	
//			MML""ň͂܂ꂽ擾B
//==============================================================
string	MMLfile::GetString(void)
{
	char	cData;
	
	string	_str;
/*
	while(cRead() != '"'){
		if(eof()){
			Err(_T("Jn\"܂B"));
		}
	}
*/
	cData = GetChar();
	if(cData != '"'){
			Err(_T("Jn\"܂B"));
	}

	while('"' != (cData = cRead())){
		if(eof()){
			Err(_T("I\"܂B"));
		}
		_str += cData;
	}
	return(_str);
}

//==============================================================
//			lǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//	
//			MML()ň͂܂ꂽ擾B
//==============================================================
int	MMLfile::GetNum(void)
{
	char	cData;
	int		iResult;
/*
	while(cRead() != '('){
		if(eof()){
			Err(_T("lJn(܂B"));
		}
	}
*/
	cData = GetChar();
	if(cData != '('){
		Err(_T("lJn(܂B"));
	}

	iResult = GetInt();
/*
	while(')' != (cData = cRead())){
		if(eof()){
			Err(_T("lI)܂B"));
		}
	}
*/
	cData = GetChar();
	if(cData != ')'){
		Err(_T("lI)܂B"));
	}

	return(iResult);
}

//==============================================================
//			lǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//==============================================================
int		MMLfile::GetInt(void)
{
				bool	neg = false;			//
				int		iResult = 0;			//Z
	unsigned	char	cData = GetChar();

	//16i
	if(cData == '$'){
		cData = cRead();
		if(cData == '+'){
			neg = false;
			cData	 = cRead();
		}
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while(((cData >= '0') && (cData <= '9')) || ((cData >= 'a') && (cData <= 'f')) || ((cData >= 'A') && (cData <= 'F'))){
			iResult <<= 4;
			if((cData >= '0') && (cData <= '9')){
				iResult += (unsigned int)cData - 0x30;
			} else if((cData >= 'A') && (cData <= 'F')){
				iResult += (unsigned int)cData - 0x41 + 10;
			} else if((cData >= 'a') && (cData <= 'f')){
				iResult += (unsigned int)cData - 0x61 + 10;
			}
			cData	 = cRead();
		}

	//Qi
	} else if(cData == '%'){
		cData = cRead();
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while((cData >= '0') && (cData <= '1')){
			iResult <<= 1;
			iResult += (unsigned int)cData - 0x30;
			cData	 = cRead();
		}

	//10i
	} else if(((cData >= '0') && (cData <= '9')) || (cData == '-') || (cData == '+')){
		if(cData == '+'){
			neg = false;
			cData	 = cRead();
		}
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while((cData >= '0') && (cData <= '9')){
			iResult *= 10;
			iResult += (unsigned int)cData - 0x30;
			cData	 = cRead();
		}

	} else {
			Err(_T("lȊOw肳܂B"));
	}

	//|C^P߂
	Back();							//	StreamPointerAdd(-1);

	//
	if(neg == true){
		iResult = -iResult;
	}

	return(iResult);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			int		LڂȂꍇ̉[tick]
//	Ԓl
//			int		[tick]
//	
//		ǂݍށit_tj
//==============================================================
int	MMLfile::readLength(int DefaultLength){

	char	cData;				//ǂݍݗp
	int		iLength;			// [tick]
	int		iDot;				//t_vZp [tick]
	int		iMod;
	int		i;

	//ǂݍ
	cData = GetChar();

	//|C^P߂
	Back();							//StreamPointerAdd(-1);

	//Length
	if(((cData >= '0') && (cData <= '9')) || (cData == '.')){
		if((cData >= '0') && (cData <= '9')){
			i = GetInt();
			if(i==0){
				Err(_T("0͎g܂B"));
			}
			iLength = (timebase * 4) / i;
			iMod	= (timebase * 4) % i;
			if(iMod != 0){
				Warning(_T("̌vZŊ؂܂łB_͐؎̂Ă܂B"));
			}
		} else {
			//t_LqꍇB
			if(DefaultLength == -1){
				Err(_T("LqĉB"));
			} else {
				iLength = DefaultLength;
			}
		}

		iDot	= iLength;
		//t_
		while((cData = cRead()) == '.'){
			if(iLength == -1){
				Err(_T("̋LqȂɕt_gꍇ́AOl R}hLqĉB"));
			}
			iMod = (iDot & 0x01);
			iDot >>= 1;
			if(iMod != 0){
				Warning(_T("t_̌vZŊ؂܂łB_͐؎̂Ă܂B"));
			}
			iLength += iDot;
		};
		Back();							//StreamPointerAdd(-1);



	//Tick
	} else if (cData == '%'){
		GetChar();	//1i߂B
		iLength = GetInt();

	} else {
		//Ȃꍇ
		if(DefaultLength == -1){
			Err(_T("LqĉB"));
		} else {
			iLength = -1;
		}
	}

	return(iLength);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			int		LڂȂꍇ̉[tick]
//	Ԓl
//			int		ǂݍ񂾐l
//					ĂȂꍇ́A -1 ԂB
//==============================================================
int		MMLfile::GetLength(int DefaultLength)	//
{
	char	cData;				//ǂݍݗp
	int		iLength;			// [tick]
	int		iCalc;
	bool	add;

	//ǂݍ
	iLength = readLength(DefaultLength);

	//̉Z
	cData = cRead();
	while((cData == '-') || (cData == '~') || (cData == '+') || ((iTieMode == 1) && (cData == '^'))){
		if(iLength == -1){
			iLength = DefaultLength;
		}

		//ŌvZ镄̃`FbN
		if((cData == '+') || (cData == '^')){
			add = true;
		} else {
			add = false;
		}
		iCalc = readLength(DefaultLength);

		if(iCalc == -1){
		//	Warning(_T("̉ZlɐlȊOw肳Ă܂B"));
			iCalc = DefaultLength;
		}

		if(add == true){
			iLength += iCalc;
		} else {
			iLength -= iCalc;
		}
		cData = cRead();
	};
	Back();							//StreamPointerAdd(-1);

	if(iLength == -1){
		return(iLength);
	}

	if((iLength < 1) || (iLength > 255)){
		Err(_T("́A%1i96j`%255i1+1+2+8j̊ԂŎw肵ĉB255[tick]𒴂ꍇ̓^C`&', `^'gĉB"));
	}

	return(iLength);
}

//==============================================================
//		R}hID̎擾
//--------------------------------------------------------------
//	
//		Command_Info*			_command
//		unsigned		int		_size
//	Ԓl
//		int			R}hR[h@i-1unknown commandj
//==============================================================
int	MMLfile::GetCommandID(const Command_Info _command[], unsigned int _size)
{
	unsigned	int		ptCommand	= tellg();	//݂̃t@C|C^ێĂB
	unsigned	int		i			= 0;		//p
	unsigned	int		j;						//`FbNp

	//R}h̃`FbN
	while(i < _size){
		StreamPointerMove(ptCommand);
		j = 0;
		do{
			if(_command[i].str[j] == 0){
				return(_command[i].id);
			}
		} while(cRead() == _command[i].str[j++]);
		i++;
	}
	return(-1);
}

//==============================================================
//		G[
//--------------------------------------------------------------
//	
//		const	_CHAR	msg[]	G[bZ[W
//	Ԓl
//				
//==============================================================
void	MMLfile::Err(const _CHAR msg[])
{

	//G[e\
	if(cOptionSW->fErr == true){
		//݂̃t@CƁAs\
		cerr << "[ ERROR ] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << ") : ";
		_CERR << msg << endl;
	} else {
		//݂̃t@CƁAs\
		cout << "[ ERROR ] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << ") : ";
		_COUT << msg << endl;
	}

	//ُI
	nsc_exit(EXIT_FAILURE);
}

//==============================================================
//		[jO
//--------------------------------------------------------------
//	
//		const	_CHAR	msg[]	[jObZ[W
//	Ԓl
//				
//==============================================================
void	MMLfile::Warning(const _CHAR msg[])
{

	//[jOe\
	if(cOptionSW->fErr == true){
		//݂̃t@CƁAs\
		cerr << "[WARNING] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << ") : ";
		_CERR << msg << endl;
	} else {
		//݂̃t@CƁAs\
		cout << "[WARNING] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << ") : ";
		_COUT << msg << endl;
	}
}
